function objectExploded(setDelimiter, valueDelimiter, value) {
  const str = 's([^v]+)v([^s]+)?';
  const rx = RegExp(
    str.replace(/v/g, valueDelimiter).replace(/s/g, setDelimiter),
    'g',
  );
  const result = {};
  let match;
  let offset = 0;
  while ((match = rx.exec(value))) {
    result[match[1]] = match[2] || '';
    offset = match.index + match[0].length;
  }
  if (offset !== value.length) return;
  return result;
}

const value = JSON.stringify({
  test: 'test',
  array: [{ id: 1 }],
  nested: {
    id: 'id',
    name: 'name',
  },
});
const result = objectExploded('&', '=', '&id=my_id&name=carmine');
console.log(result);
